//------------------------------------------------------------------------------
// (C)2001 Dipl.-Ing Horst-Dieter Kassl  (HD@Kassl.de)
//------------------------------------------------------------------------------
// Example for class TdopcServerBrowser

unit uMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, dOPC;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    eComputername: TEdit;
    Label1: TLabel;
    bSearch: TButton;
    ListView1: TListView;
    ServerBrowser: TdopcServerBrowser;
    procedure bSearchClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function ISTypeOf(Test: boolean): string;
begin
  if Test then
    result := 'X'
  else
    result := ' ';
end;

procedure TForm1.bSearchClick(Sender: TObject);
var
  i        : integer;
  ListItem : TListItem;
  OldCursor: TCursor;
begin
  ListView1.Items.Clear;        // clear all Items
  OldCursor := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  ServerBrowser.Computername := eComputerName.Text;
  try
    ServerBrowser.Execute;     // get Serverlist from given Computer
  finally
    Screen.Cursor := OldCursor;
  end;

  for i := 0 to ServerBrowser.Count-1 do   // for each Servers in list
  begin
     ListItem := ListView1.Items.Add;      // new Item for Listview
     with ServerBrowser[i] do
     begin
       ListItem.Caption := ServerCaption;  // add Serverinfo to Listview
       ListItem.SubItems.Add(ServerName);
       ListItem.SubItems.Add(ServerClsId);
       ListItem.SubItems.Add(IsTypeOf(svr_DA10 in ServerType));
       ListItem.SubItems.Add(IsTypeOf(svr_DA20 in ServerType));
       ListItem.SubItems.Add(IsTypeOf(svr_AE10 in ServerType));
     end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  dOPCInitSecurity;   // this is for DCOM
end;

end.
